%define prefix /opt/monitor

Summary: op5 Monitor Networkmap
Name: monitor-networkmap
Version: 3.3.5
Release: op5.1
License: op5 Immaterial Works License
Group: op5/monitor
Source0: %name-%version.tar.gz
Vendor: op5 AB
Requires: monitor-gui >= 3.3.5
Prefix: %prefix
BuildArch: noarch
BuildRoot: /override/%name-%version


%description
op5 Monitor Networkmap is a point-and-click action network
topology view add-on for op5 Monitor.


%prep
%setup -q

%install
rm -rf %buildroot
mkdir -p -m 755 %buildroot%prefix/op5/networkmap
mv * %buildroot%prefix/op5/networkmap
chmod 777 %buildroot%prefix/op5/networkmap/backgrounds
chmod 755 %buildroot%prefix/op5/networkmap/img
chmod 755 %buildroot%prefix/op5/networkmap/tree

sed -i %buildroot%prefix/op5/networkmap/smap_config.inc.php \
    -e 's/@VERSION@/%{version}-%{release}/'

%files
%defattr(644,root,root,755)
%prefix/op5/networkmap


%post
# Verify that mysql-server is installed and running before executing sql scripts
$(mysql -Be "quit" 2>/dev/null)
if [ $? -eq 0 ]; then
  # install, create tables if not exists, alter if exist
  if [ $1 -eq 1 ]; then

	mysql monitor_gui < %prefix/op5/networkmap/smap.sql
	mysql monitor_gui -e "ALTER TABLE smap_view ADD is_hostgroup tinyint(3) unsigned" >& /dev/null
	mysql monitor_gui -e "UPDATE smap_view RIGHT JOIN hostgroup ON smap_view.name=hostgroup.hostgroup_name SET smap_view.is_hostgroup=1"
	mysql monitor_gui -e "UPDATE smap_view SET name='Root view' WHERE name='*' AND id=1"
  fi
fi

#Moving from dir statusmap to networkmap, copy old backgrounds
if [ -d %prefix/op5/statusmap/backgrounds ]; then
   cp -p /opt/monitor/op5/statusmap/backgrounds/*.png /opt/monitor/op5/networkmap/backgrounds/ >& /dev/null
   chmod 666 /opt/monitor/op5/networkmap/backgrounds/*.png >& /dev/null
fi

%clean
rm -rf %buildroot


%changelog
* Fri Dec 17 2004 Andreas Ericsson <ae@op5.se> 1.0-op5.0b1
- Initial package date.  Changelog maintained in CVS.
