<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

require_once('smap_utils.inc.php');

$MAP = 0;
$BLACK = 0;
$WHITE = 0;
$GREY = 0;
$host_array = 0;

$status_code['service'] =
  array(0 => 'ok', 1 => 'warning', 2 => 'critical', 3 => 'unknown');
$status_code['host'] =
  array(0 => 'up', 1 => 'down', 2 => 'unreachable');


// Creates and returns an image resource in any of the supported formats.
// All directories in $icon_dir array are searched for it
function create_image($image) {
	// paths to search
	$icon_dir = array('.', './backgrounds', '/opt/monitor/share/images/logos');
	// suffix to lamda function list
	$suffix = array('gd2' => 'imagecreatefromgd2',
					'png' => 'imagecreatefrompng',
					'jpg' => 'imagecreatefromjpeg',
					'jpeg' => 'imagecreatefromjpeg',
					'gif' => 'imagecreatefromgif');

	$tmp = explode('.', $image);
	$suf = array_pop($tmp);
	if(isset($suffix[$suf])) {
		$image = implode('.', $tmp);
	}

	$img_list = false;
	foreach($suffix as $suf => $func) {
		if(!function_exists($func)) continue;

		// set up all the places we are to look for the image
		$img_list = false;
		$img_list[] = "$image.$suf";
		foreach($icon_dir as $dir) {
			$img_list[] = "$dir/$image.$suf";
		}
		foreach($img_list as $img) {
			if(is_file($img)) return($func($img));
		}
	}

	return(ImageCreateFromGD2('/opt/monitor/share/images/logos/unknown.gd2'));
}

function get_host_logos() {
	$ret = false;

	$query = 'SELECT host_name, statusmap_image FROM host ' .
		'WHERE host.statusmap_image != ""';

	$result = sql_exec_query($query);
	while($row = sql_fetch_row($result)) {
		$ret[$row[0]] = $row[1];
	}

	return($ret);
}

function parse_host_status($host) {
	global $status;
	global $status_code;

	$tmp = false;

	// by now all hosts in $cont['host'] should be in status as well
	foreach($status_code['service'] as $sc => $sm) {
		$tmp[$sm] = 0;
	}

	if(!isset($status['service'][$host])) {
		return($tmp);
	}

	$srv_list = $status['service'][$host];
	foreach($srv_list as $service) {
		$sm = $status_code['service'][$service['current_state']];
		$tmp[$sm]++;
	}

	return($tmp);
}

function parse_view_status(&$view_list) {
	global $view;
}

function get_view_details($view) {

	if(empty($view)) $view = 1;

	$query = 'SELECT * FROM smap_view WHERE id = \'' .
	  mysql_escape_string($view) . '\'';
	$result = sql_exec_query($query);
	$rows = mysql_num_rows($result);
	if(!$rows) {
		return(get_view_details(false));
	}

	return(sql_fetch_array($result));
}

function get_view_content($view) {
	global $status;
	global $status_code;
	global $host_logos;
	global $auth;
	global $auth_for_all;
	get_auth_for_all();

	// this saves a lot of silly errors later
	$cont = array('host' => array(), 'view' => array());

	if($view === false) return(false);
	$query = "SELECT view, host, x, y FROM smap_content " .
	  "WHERE smap_view = '$view[id]' ORDER BY y";
	$result = sql_exec_query($query);

	while($row = sql_fetch_array($result)) {
		$this_view = $row['view'];
		$this_host = $row['host'];
		unset($row['host']);
		unset($row['view']);

		if(!empty($this_host)) {
			$row['name'] = $this_host;
			$cont['host'][$this_host] = $row;
			continue;
		}

		// we're dealing with a view, so get its details
		$v = get_view_details($this_view);
		if(empty($v)) continue;
		$cont['view'][$v['name']] = $row;
		$cont['view'][$v['name']]['id'] = $v['id'];
		$cont['view'][$v['name']]['name'] = $v['name'];
	}

	if(empty($cont)){
		echo "empty";
		return(false);
	}
	// remove objects this user isn't authorized to see, and fix
	// everything else in the process
	if(!empty($cont['host'])) foreach($cont['host'] as $k => $host) {
		// delete hosts this user isn't allowed to see
		if(!isset($status['host'][$k])) {
			unset($cont['host'][$k]);
		}
		if(!($auth===true) && !isset($auth['host'][$k])) {
			unset($cont['host'][$k]);
			continue;
		}

		// get this hosts status
		$tmp = parse_host_status($k);
		foreach($tmp as $sc => $sc_num) {
			$cont['host'][$k][$sc] = $sc_num;
		}

		if(isset($host_logos[$k])) {
			$tmp = $host_logos[$k];
			$tmp = explode('.', $tmp);
			array_pop($tmp);
			if(!empty($tmp)) {
				$cont['host'][$k]['icon'] = implode('.', $tmp);
			}
			else {
				$cont['host'][$k]['icon'] = $host_logos[$k];
			}
		}
		else {
			$cont['host'][$k]['icon'] = 'unknown';
		}

		$cont['host'][$k]['status'] = $status['host'][$k]['current_state'];

		$parents = get_parents($k);
		foreach($parents as $p) {
			if(isset($cont['host'][$p])) {
				$cont['host'][$k]['parents'][] = $p;
			}
		}
	}

	if(!empty($cont['view'])) foreach($cont['view'] as $k => $v) {

		if(empty($k)) die("k is empty");

		$query = 'SELECT host FROM smap_content WHERE smap_view = \'' .
		  mysql_escape_string($v['id']) . '\' AND host != \'\'';
		$result = sql_exec_query($query);

		$up = $down = $unreach = 0;
		$host = array();
		$the_hosts = get_host_recursive($v['id']); //
		foreach($the_hosts as $h){ //
			if(!isset($status['host'][$h])) continue;
			if(!($auth===true) && !isset($auth['host'][$h])) continue; /////// new 050523
			$host[] = $h;

			if($status['host'][$h]['current_state'] === '0') {
				$up++;
			}
			elseif($status['host'][$h]['current_state'] === '1') {
				$down++;
			}
			else {
				$unreach++;
			}
		}

		if(!($auth_for_all===true) && !$up && !$down && !$unreach) {
			// no hosts checked, so user shouldn't see this view
			unset($cont['view'][$k]); /////// new 050523
			continue;
		}
		$cont['view'][$k]['status']['up'] = $up;
		$cont['view'][$k]['status']['down'] = $down;
		$cont['view'][$k]['status']['unreachable'] = $unreach;

		foreach($status_code['service'] as $sc => $sm) {
			$cont['view'][$k]['status'][$sm] = 0;
		}
		foreach($host as $h) {
			$tmp = parse_host_status($h);
			foreach($tmp as $sm => $sm_num) {
				$cont['view'][$k]['status'][$sm] += $sm_num;
			}
		}
	}

	return($cont);
}

// create the global image resource $MAP which will be returned
// as a png-image to the browser
function init_map($x,$y) {
	global $MAP;
	global $BLACK;
	global $WHITE;
	global $GREY;
	global $RED;
	global $YELLOW;

	global $text_border_size;
	global $icon_width;
	global $icon_height;
	global $status_border_width;
	global $font_size;
	global $service_font_size;
	global $view;
	global $scale;

	$height = MAP_HEIGHT * $scale;
	$width = MAP_WIDTH * $scale;

	$height=$y * $scale;
	$width=$x * $scale;

	// Scale the map objects' size with the scale supplied by the user
	$text_border_size = TEXT_BORDER_SIZE * $scale;
	$icon_width = ICON_WIDTH * $scale;
	$icon_height = ICON_HEIGHT * $scale;
	$status_border_width = STATUS_BORDER_WIDTH * $scale;

	$font_size = FONT_SIZE * $scale;
	$service_font_size = FONT_SIZE * $scale;

	// We don't want a font that is to small to read
	if($font_size < MIN_FONT_SIZE) $font_size = MIN_FONT_SIZE;
	if($service_font_size < MIN_FONT_SIZE) $service_font_size = MIN_FONT_SIZE;

	$MAP = ImageCreateTrueColor($width, $height);

	$BLACK = imageColorAllocate($MAP, 0x00, 0x00, 0x00);
	$WHITE = imageColorAllocate($MAP, 0xFF, 0xFF, 0xFF);
	$GREY = imageColorAllocate($MAP,0x99,0x99,0x99);
	$RED = imageColorAllocate($MAP, 0xFF, 0x00, 0x00);
	$YELLOW = imageColorAllocate($MAP, 0xFF, 0xFF, 0x00);

	// Background of the picture
	ImageFilledRectangle($MAP, 0, 0, 1024, 768, $WHITE);
}

// Clean up in memory. Probably done by php when script ends...
function destroy_map() {
	global $MAP;

	imageDestroy($MAP);
}

// put host info on the map on the given coordinates
function plot_host(&$statusmap_image, $status_map_im_width, $status_map_im_height, &$log_status_image, $log_im_width, $log_im_height, $warning_service, $critical_service, $draw_service_indicators, $infostring ,$x, $y) {
	global $MAP;
	global $BLACK;
	global $WHITE;
	global $GREY;
	global $RED;
	global $YELLOW;

	global $text_border_size;
	global $icon_width;
	global $icon_height;
	global $status_border_width;
	global $font_size;
	global $service_font_size;
	global $scale;


	$x = $x * $scale;
	$y = $y * $scale;

	// display service info.
	if($critical_service) { // && $draw_service_indicators) {
		draw_text_box($service_font_size, 0,
					  $x + $icon_width + $status_border_width * 2,
					  $y + $service_font_size + 3,
					  $BLACK, $RED, MAP_FONT, "C: $critical_service", 1);
	}

	if($warning_service) { // && $draw_service_indicators) {
		draw_text_box($service_font_size, 0,
					  $x + $icon_width + $status_border_width * 2,
					  $y + $service_font_size * 3,
					  $BLACK, $YELLOW, MAP_FONT, "W: $warning_service", 1);
	}

	// put images on map
	imagecopyresampled($MAP, $log_status_image, $x, $y, 0, 0,
					   $icon_width + $status_border_width * 2,
					   $icon_height + $status_border_width * 2,
					   $log_im_width, $log_im_height);
	imagecopyresampled($MAP, $statusmap_image,
					   $x + $status_border_width,
					   $y + $status_border_width,
					   0, 0, $icon_width, $icon_height,
					   $status_map_im_width, $status_map_im_height);

	// print hostname and status on map
	draw_text_box($font_size, 0, $x, $y,
				  $BLACK, $GREY, MAP_FONT,$infostring, 1);
}

// draw lines between hosts and their parents.
// end points are read from the global $host_array.
function draw_parent_lines($hosts) {
	global $host_array;
	global $MAP;
	global $BLACK;
	global $hosts_authorized_for;

	global $font_size;
	global $service_font_size;
	global $text_border_size;
	global $icon_width;
	global $icon_height;
	global $status_border_width;
	global $scale;

#	echo "<pre>\n"; print_r($hosts); echo "</pre>\n";
	foreach($hosts as $k => $attribs) {
		// skip this host if ...
		// .. it doesn't have parents
		if(empty($attribs['parents'])) {
			continue;
		}

		// basics are met, now check the parents
		foreach($attribs['parents'] as $parent) {
			// skip this parent if ...
			// .. either coordinate value isn't set
			if(!isset($hosts[$parent]['x']) ||
			   !isset($hosts[$parent]['y'])) {
				continue;
			}

			ImageLine($MAP, $attribs['x'] * $scale + $icon_width,
					  $attribs['y'] * $scale + $icon_height,
					  $hosts[$parent]['x'] * $scale + $icon_width,
					  $hosts[$parent]['y'] * $scale + $icon_height,
					  $BLACK);
		}
	}
}

// put a box with the supplied text on the map.
function draw_text_box($font_size, $angle, $x, $y, $text_colour, $bg_colur, $font, $text, $border_size) {
    global $MAP;
    global $BLACK;
    global $WHITE;
    global $GREY;
    global $RED;
    global $YELLOW;

    $text_boundaries = imagettfbbox($font_size, $angle, $font, $text);

	ImageFilledRectangle($MAP, $x + $text_boundaries[6],
						 $y - ($font_size + $border_size * 2),
					     $x + $text_boundaries[2] + $border_size * 2,
						 $y, $bg_colur);

 	ImageTTFText($MAP, $font_size, $angle, $x + $border_size,
				 $y - $border_size, $text_colour, $font, $text);
}

function plot_view(&$smap_image, $smap_img_width, $smap_img_height, $info_strings, $x, $y) {
	global $MAP;
	global $BLACK;
	global $GREY;
	global $WHITE;
	global $font_size;
	global $text_border_size;
	global $icon_width;
	global $icon_height;
	global $scale;

	$x = $x * $scale;
	$y = $y * $scale;

	$box_height = $font_size + $text_border_size * 2;
	draw_text_box($font_size, 0, $x, $y, $BLACK, $WHITE,
				  MAP_FONT, $info_strings[0], $text_border_size);

	imagecopyresampled($MAP, $smap_image, $x, $y, 0, 0,
					   $icon_width * 2, $icon_height * 2,
					   $smap_img_width, $smap_img_height);

	$acc_height = $y + $icon_height;

	// print viewname and status on map
	$strings = array_slice($info_strings, 1);
	$i = 2;
	foreach($strings as $k => $v) {
		if(!empty($v)) {
			draw_text_box($font_size, 0, $x,
						  ($acc_height + ($box_height * ($i + 1))),
						  $BLACK, $WHITE, MAP_FONT, $v, $text_border_size);
			$i++;
		}
	}
}

function get_pic_size($picture){

	if(!$picture)
	  $picture=BACKGROUND;
	$tmpimg=imagecreatefrompng("backgrounds/" . $picture . ".png");
	$retvat= array();
	$retval['x']=imagesx($tmpimg)-ICON_WIDTH;
	$retval['y']=imagesy($tmpimg)-ICON_WIDTH;
	return $retval;
}

?>
