<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

require_once('/opt/monitor/op5/gui/gui_api.inc.php');
require_once('/opt/monitor/op5/gui/status.inc.php');
require_once('smap_config.inc.php');
require_once('smap_image_utils.inc.php');
require_once('smap_utils.inc.php');

gui_init();
get_current_status();

// some global variables
$scale = '1.0';
$view = false;	// the view we're looking at
$background = 'backgrounds/sverige.png';	// the default background
$background = 'sverige';	// the default background
$status_images = array();	// images cached in memory from 'createfrom'
$draw_service_indicators = false;

/***************** main code start ********************/

if(!empty($_GET['view'])) $view = $_GET['view'];
if(!empty($_GET['scale'])) $scale = $_GET['scale'];
if(!empty($_GET['bg'])) $background = $_GET['bg'];
if(!is_numeric($scale)) $scale = 1.0;
$icon_width = ICON_WIDTH * $scale;
$icon_height = ICON_WIDTH * $scale;

$host_logos = get_host_logos();
$view = get_view_details($view);
if(empty($view['background'])) {
	$view['background'] = get_default_background();
}

$cont = get_view_content($view);
if($cont === false) die("No content in this map");

// put the background image on the map, calculate where to put the hosts,
// read host and status images into memory and send the picture to the
// webbrowser.
$acc_width = START_WIDTH;
$acc_height = START_HEIGHT;

// get the background
$bg_img = create_image($view['background']);
$bg_org_width = ImageSx($bg_img);
$bg_org_height = ImageSy($bg_img);

init_map($bg_org_width, $bg_org_height);


// put background on the map
imagecopyresampled($MAP, $bg_img, 0, 0, 0, 0,
				   $bg_org_width * $scale,
				   $bg_org_height * $scale,
				   $bg_org_width, $bg_org_height);

$statusmap_images = array();
$logstatus_images = array();

// load the images for each host and plot them
if(!empty($cont['host'])) {
	foreach($cont['host'] as $host_name => $host) {

		// print in a row if coords not set, and save to database while
		// we auto-invent them
		if(empty($host['x']) && empty($host['y'])) {

			// remeber where the images are
			$cont['host'][$host_name]['x'] = $host['x'] = $acc_width;
			$cont['host'][$host_name]['y'] = $host['y'] = $acc_height;

			// recalculate for next lined up image
			//$acc_height += ICON_HEIGHT + FONT_SIZE + STATUS_BORDER_WIDTH * 2;
			$acc_height += ICON_HEIGHT + FONT_SIZE + STATUS_BORDER_WIDTH * 6;

			// If the icons fills the MAP_HEIGHT in one row, start a new
			if(($acc_height + ICON_HEIGHT + FONT_SIZE * 3) > (MAP_HEIGHT - START_HEIGHT * 2)) {
				$acc_width += START_WIDTH + ICON_WIDTH * 2;
				$acc_height = START_HEIGHT;
			}

			// non-indexed table, so we must delete manually first (fix later)
			$query = 'DELETE FROM smap_content ' .
			  "WHERE smap_view = '$view[id]' AND host = '$host[name]'";
			sql_exec_query($query);

			$query = "REPLACE INTO smap_content(smap_view, host, x, y) " .
			  "VALUES('$view[id]', '$host[name]', '$host[x]', '$host[y]')";
			$result = sql_exec_query($query);
			$draw_service_indicators = true;

		}

		// load the image for current status if it isn't already in memory
		if(!isset($status_images[$host['status']])) {
			$status_images[$host['status']] =
			  imagecreatefrompng(ICONPATH . $host['status'] . '.png');
		}

		// get picture size
		$stat_org_width = ImageSx($status_images[$host['status']]);
		$stat_org_height = ImageSy($status_images[$host['status']]);
		// print hostname and status on map
		$hoststring = $host['name'] . "-" . $host['status'];

		// load the image for current host if it isn't already in memory
		if(!isset($icons[$host['icon']])) {
			$icons[$host['icon']] = create_image($host['icon']);
		}

		// get the size of the picture
		$org_width = ImageSx($icons[$host['icon']]);
		$org_height = ImageSy($icons[$host['icon']]);

		// put images on map
		if($host['status'] !== 0) $draw_service_indicators = false;
		else $draw_service_indicators = true;

		plot_host($icons[$host['icon']],
				  $org_width, $org_height,
				  $status_images[$host['status']],
				  $stat_org_width, $stat_org_height,
				  $host['warning'], $host['critical'],
				  $draw_service_indicators,
				  $host['name'], $host['x'], $host['y']);
	}

	draw_parent_lines($cont['host']);
}

// now draw the views. The map is already initialized, so we don't need to
// bother with that.
$global_view = $view;

// load the status logotypes in memory and fire away
$all_ok_img = imagecreatefrompng("all_ok.png");
$all_ok_img_width = ImageSx($all_ok_img);
$all_ok_img_height = ImageSy($all_ok_img);

$some_down_img = imagecreatefrompng("some_down.png");
$some_down_img_width = ImageSx($some_down_img);
$some_down_img_height = ImageSy($some_down_img);

$all_down_img = imagecreatefrompng("all_down.png");
$all_down_img_width = ImageSx($all_down_img);
$all_down_img_height = ImageSy($all_down_img);

$draw_service_indicators = false;
if(!empty($cont['view'])) foreach($cont['view'] as $view_name => $view) {
	// only show host if it belongs to current view and the user has
	// the right to see it
	// If the coordinates are set, print host accordingly, else print
	// them in a row
	if(empty($view['x']) && empty($view['y'])) {
		// remeber where the images are
		$cont['view'][$view_name]['x'] = $view['x'] = $acc_width;
		$cont['view'][$view_name]['y'] = $view['y'] = $acc_height;

		// query to change selected host's coordinates in current view
		$query = "UPDATE smap_content SET x = $acc_width, y = $acc_height " .
			  "WHERE smap_view = $global_view[id] AND view = $view[id]";
		$result = sql_exec_query($query);

		// how much of the screen is used
		$acc_height += ICON_HEIGHT + FONT_SIZE + STATUS_BORDER_WIDTH * 6;

		// If the icons fills the MAP_HEIGHT in one row, start a new
		if(($acc_height + ICON_HEIGHT + FONT_SIZE * 3) > (MAP_HEIGHT - START_HEIGHT * 2)) {
//			$acc_width += START_WIDTH + ICON_WIDTH * 4;
			$acc_width += START_WIDTH + ICON_WIDTH * 2;
			$acc_height = START_HEIGHT;
		}
	}

	$draw_service_indicators = FALSE;

	// print hostname and status
	$info_strings[0] = $view['name'];

	if(!empty($view['status']['up']) && !empty($view['status']['down'])) {
		$info_strings[1] = TXT_UP . ': ' . $view['status']['up'] .
		  ", " . TXT_DOWN . ': ' . $view['status']['down'];
	}
	else {
		$info_strings[1] = false;
	}

	if(!empty($view['status']['unreachable'])) {
		if($info_strings[1]){
			$info_strings[1]=$info_strings[1] . ", ";
		}
		$info_strings[1] = $info_strings[1] . TXT_UNREACHABLE . ": " .
		  $view['status']['unreachable'];
	}

	if(!empty($view['status']['critical'])) {
		$info_strings[2] = TXT_CRITICAL . ": " . $view['status']['critical'];
	}
	else {
		$info_strings[2] = false;
	}
	if(!empty($view['status']['warning'])) {
		$info_strings[3] = TXT_WARNING . ": " . $view['status']['warning'];
	}
	else {
		$info_strings[3] = false;
	}

	// fill out the gory details, if any
	if(!empty($view['status']['up']) ||
	   !empty($view['status']['down']) ||
	   !empty($view['status']['warning']) ||
	   !empty($view['status']['critical']) ||
	   !empty($view['status']['unreachable']))
	{
		if($view['status']['down'] === 0 &&
		   $view['status']['up'] !== 0 &&
		   $view['status']['unreachable'] === 0 &&
		   $view['status']['critical'] === 0 &&
		   $view['status']['warning'] == 0)
		{
			plot_view($all_ok_img, $all_ok_img_width,
					  $all_ok_img_height, $info_strings,
					  $view['x'], $view['y']);
		}
		elseif($view['status']['down'] !== 0 &&
			   $view['status']['up'] === 0 &&
			   $view['status']['unreachable'] === 0)
		{
			plot_view($all_down_img, $all_down_img_width,
					  $all_down_img_height, $info_strings,
					  $view['x'], $view['y']);
		}
		else {
			plot_view($some_down_img, $some_down_img_width,
					  $some_down_img_height, $info_strings,
					  $view['x'], $view['y']);
		}
	}
	else {
		plot_view($some_down_img,
				  $some_down_img_width, $some_down_img_height,
				  $info_strings,  $view['x'], $view['y']);
	}
}

header('Content-Type: image/png');
header('Cache-Control: no-cache');
header('Cache-Control: must-revalidate, max-age=0');
header("Expires: " . date("r", 0));
ImagePNG($MAP);

destroy_map();

?>
