<?php
/*
 * Copyright(C) op5 AB
 * All rights reserved.
 */

require_once('/opt/monitor/op5/gui/gui_api.inc.php');
require_once('/opt/monitor/op5/gui/db_utils.inc.php');
require_once('smap_config.inc.php');
require_once('smap_image_utils.inc.php');

// sets up the playground. All pages get the same generic look.
function html_start() {
	header('Cache-Control: no-cache');
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n\n";

?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
		<head>
			<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-1" />
			<meta name="robots" content="noindex, nofollow" />
			<meta name="author" content="My Appelgren, op5 AB" />
			<meta http-equiv="Pragma" content="no-cache" />
			<meta http-equiv="Pragma-directive" content="no-cache" />
			<meta http-equiv="Cache-directive" content="no-cache" />
			<meta http-equiv="Expires" content="0" />
			<title> op5 Monitor &raquo; Networkmap</title>
			<link type="text/css" rel="stylesheet" href="/monitor/css/common.css" />
			<link type="text/css" rel="stylesheet" href="/monitor/css/tables.css" />
			<link type="text/css" rel="stylesheet" href="statusmap.css" />
<?php
}


function get_auth_for_all(){
	global $auth_for_all;
	global $cgi_config;
	$auth_for_all=false;

	if(!isset($_SERVER['REMOTE_USER'])) return(false);
	$user = $_SERVER['REMOTE_USER'];

	if(in_array($user, $cgi_config['authorized_for_system_commands']) &&
	   in_array($user, $cgi_config['authorized_for_configuration_information']))
	{
		$auth_for_all = true;
	}
	if(in_array("*", $cgi_config['authorized_for_system_commands']) &&
	   in_array("*", $cgi_config['authorized_for_configuration_information']))
	{
		$auth_for_all = true;
	}
}

// read the backgrounds (only .png images, which have suffixes cut)
function get_map_backgrounds() {
	$bgs = glob(BG_DIR . '/*.png', GLOB_MARK);
	foreach($bgs as $k => $v) {
		if(substr($v, -4) !== '.png') continue;
		$v = array_pop(explode('/', $v));
		$bgs[$k] = substr($v, 0, -4);
	}
	return($bgs);
}

/* Get backgroud for this view */
function get_map_background($view){
	$tmp = sql_exec_query("SELECT background FROM smap_view WHERE id=$view");
	while($row = sql_fetch_row($tmp)) {
		if($row[0]){
		  	return $row[0];
		}
		else {
			return get_default_background();
		}
	}
	return get_default_background();
}

/* Fetch first hostgroup  */
/**/
function get_first_view(){
	$views_tmp = sql_exec_query("SELECT DISTINCT id, name FROM smap_view " .
								"WHERE id!='1' AND is_hostgroup=1 ORDER BY name");

	while($row = sql_fetch_row($views_tmp)) {
		// check user access stuff
		if(user_has_rights($row[0]))
			return $row[0];
	}

    return 0;
}
/* Fetch first custom view, used when changing from view to hostgroup and w.v. */
function get_first_custom_view(){
	$views_tmp = sql_exec_query("SELECT DISTINCT id, name FROM smap_view LEFT JOIN smap_content ON id=view " .
								"WHERE smap_view=1 AND is_hostgroup is null ORDER BY id");

	while($row = sql_fetch_row($views_tmp)) {
		return $row[0];
	}
    return 0;
}

/* Add custom view */
function add_view($view_name, $parent_view){
 /* CHECK NAME!!!!!!!.... */
	$uniqueName = check_name_unique($view_name);
	if(!$uniqueName){
		return 0;
	}
	sql_exec_query("INSERT INTO smap_view (name) VALUES ('" .
				   mysql_escape_string($view_name) . "')");
	$new_view_id_arr=sql_exec_query("SELECT MAX(id) FROM smap_view");
	$new_view_id=sql_fetch_row($new_view_id_arr);
	$coords = get_new_item_coords($parent_view, "view");
	sql_exec_query("INSERT INTO smap_content (smap_view, view,x,y) VALUES ".
				   "('$parent_view', '$new_view_id[0]', " .
				   $coords['x'] . ", " . $coords['y']  . " )");
	return $new_view_id[0];
}

/* Add host to view */
function add_host_to_view($host, $view){
	$coords = get_new_item_coords($view, "host");
	sql_exec_query("INSERT INTO smap_content (smap_view, host, x, y) ".
	               "VALUES ('$view', '" . mysql_escape_string($host) .
	               "', ". $coords['x'] . ", " . $coords['y']  . " )");
}

/* Add view to view */
function add_view_to_view($new_view, $parent_view){
	$coords = get_new_item_coords($parent_view, "view");
	sql_exec_query("INSERT INTO smap_content (smap_view, view, x, y) " .
	               "VALUES ('$parent_view)','$new_view', " .
	               $coords['x'] . ", " . $coords['y'] . ")");
}

/* Remove host from view */
function delete_host_from_view($host, $view){
	sql_exec_query("DELETE FROM smap_content WHERE smap_view="
				   . $view . " AND host='" . $host . "'");
}

/* Delete view from view */
function delete_view_from_view($the_view, $parent_view){
	sql_exec_query("DELETE FROM smap_content WHERE smap_view='$parent_view' " .
				   "AND view='$the_view'");
}


/* Get view content, key=view id or host name, value=host/view name */
function get_content($view){
	$obj_list = array();
	global $auth;
    $result = sql_exec_query('SELECT  smap_view.id, smap_view.name ' .
							 'FROM smap_view, smap_content ' .
				             'WHERE smap_view.id = smap_content.view ' .
				             'AND smap_content.smap_view = \'' .
				              mysql_escape_string($view) . '\'');
	while($row = sql_fetch_row($result)) {
		if(user_has_rights($row[0]))
			$obj_list[$row[0]] = $row[1];
	}
	$result = sql_exec_query('SELECT host FROM smap_content WHERE '.
							 'smap_content.smap_view = \'' .
				             mysql_escape_string($view) . '\' AND host != \'\'');
	while($row = sql_fetch_row($result)) {
		if($auth===true || isset($auth['host'][$row[0]]))
			$obj_list[$row[0]] = $row[0];
	}

	return $obj_list;
}

/* Get all custom views */
function get_custom_view_info(){
	$tmp = sql_exec_query("SELECT view, smap_view, name FROM smap_content LEFT JOIN " .
						  "smap_view ON id=view WHERE view IS NOT NULL AND id!='1'" .
						  "AND is_hostgroup IS NULL ORDER BY name");
	$tmp2 = sql_fetch_result($tmp);
	if (is_array($tmp2) && !empty($tmp2)) {
		foreach($tmp2 as $val=>$val2){
			if(!user_has_rights($val2['view']))
				unset($tmp2[$val]);
		}
	}
	return $tmp2;
}

function get_root_name(){
	$tmp = sql_exec_query("SELECT name FROM smap_view WHERE id=1");
	$row = sql_fetch_row($tmp);
	return $row[0];
}
function get_view_name($view){
	$tmp = sql_exec_query("SELECT name FROM smap_view WHERE id=$view");
	$row = sql_fetch_row($tmp);
	return $row[0];
}

/* 	Ugly, recursive function which returns all custom formated in
	a 'hierarcy'. Like so:
	Sweden
	- Gothenburg
	- - Linne
	- Stockholm
	Norway
	- Oslo
	...
 */
function get_all_custom_viewsR($parent, $str){
	$views_tmp = sql_exec_query("SELECT DISTINCT id, name FROM smap_view LEFT JOIN smap_content ON id=view " .
								"WHERE smap_view=$parent AND is_hostgroup is null ORDER BY name");
	$views=array();
	while($row = sql_fetch_row($views_tmp)) {
//////////////// user access???
		if(user_has_rights($row[0])){ // user rights stuff
			$views[$row[0]] =$str . $row[1];
			$views2 = get_all_custom_viewsR($row[0], "- " . $str);
			foreach($views2 as $a => $b){
				$views[$a]=  $b;
			}
		}
	}
    return $views;
}


function user_has_rights($view){
	$hosts = sql_exec_query("SELECT host FROM smap_content WHERE smap_view=" .
							$view . " AND host IS NOT NULL");
	global $auth_for_all;
	global $auth;
	$retval=false;
	if($auth_for_all===true)
	  return true;
	while($one_host = sql_fetch_row($hosts)){
		if($auth===true || isset($auth['host'][$one_host[0]])){
		  	return true;
		}
	}
	$views = sql_exec_query("SELECT view FROM smap_content WHERE smap_view=" .
							$view . " AND view IS NOT NULL");
	while($one_view = sql_fetch_row($views)){
		if(user_has_rights($one_view[0]))
		  $retval=true;
	}
	return $retval;
}


function copy_custom_viewsR($old_parent, $new_parent, $name){
	$views_tmp = sql_exec_query("SELECT DISTINCT id, name FROM smap_view LEFT JOIN smap_content ON id=view " .
								"WHERE smap_view=$old_parent AND is_hostgroup is null ORDER BY name");

	echo "INSERT INTO smap_view (name) VALUES ('" . $name ."')" ;
	while($row = sql_fetch_row($views_tmp)) {
		copy_custom_viewsR($old_parent, $row[0], $row[1]);
		echo "INSERT INTO smap_content (smap_view, view) " .
					   "VALUES (" . $new_parent . ", " . $row[0] . ")";
	}
}

/* Get all hostgroups in a view */
function get_all_views2($me){
	$views_tmp = sql_exec_query("SELECT DISTINCT id, name FROM smap_view " .
								"WHERE id!='1' AND id!='$me' AND is_hostgroup=1 ORDER BY name");
	$views=array();
	while($row = sql_fetch_row($views_tmp)) {
		if(user_has_rights($row[0]))
			$views[$row[0]]=$row[1];
	}
    return $views;
}

/* Get all hostgroups in a view */
function get_all_hostgroups($me){
	$views_tmp = sql_exec_query("SELECT DISTINCT id, name FROM smap_view " .
								"WHERE id!='1' AND id!='$me' AND is_hostgroup=1 ORDER BY name");
	$views=array();
	while($row = sql_fetch_row($views_tmp)) {
		if(user_has_rights($row[0])) // user access stuff
			$views[$row[0]]=$row[1];
	}
    return $views;
}

/* Update host and view coords, used to keep stuff on map when chaning 	*/
/* to a smaller map. 													*/
function update_coords($view, $background){
	$retval=get_pic_size($background);
	$tmp = sql_exec_query("SELECT view, host FROM smap_content WHERE " .
						  "x>" . $retval['x'] . " OR y>" . $retval['y'] .
						  " AND smap_view=" . $view);

	while($row = sql_fetch_row($tmp)) {

		if($row[0]){
			$retval = get_new_item_coords($view, "view");
			sql_exec_query("UPDATE smap_content SET x=" . $retval['x'] .
						   ", y=" . $retval['y'] . " WHERE view=" . $row[0] .
						   " AND smap_view=" . $view);
		}
		if($row[1]){
			$retval = get_new_item_coords($view, "host");
			sql_exec_query("UPDATE smap_content SET x=" . $retval['x'] .
						   ", y=" . $retval['y'] . " WHERE host='" . $row[1] . "'" .
						   " AND smap_view=" . $view);
		}
	}
}


/* Get all hostgroups in this view */
function get_hostgroups_in_view($view){
	$tmp = sql_exec_query("SELECT DISTINCT view FROM smap_content LEFT JOIN " .
						  "smap_view ON id=smap_content.smap_view WHERE " .
						  "smap_content.smap_view='" .
						  mysql_escape_string($view) . "' AND NOT view=''");

	$dbStr = "SELECT DISTINCT id, name FROM smap_view WHERE id IN (";

	while($row = sql_fetch_row($tmp)){
		$dbStr=$dbStr . "'$row[0]', ";
	}
	$dbStr=$dbStr . "'') AND is_hostgroup=1 ORDER BY name";
	$i=0;

	$views_tmp = sql_exec_query($dbStr);
	$views =array();
	while($row = sql_fetch_row($views_tmp)) {
		if(user_has_rights($row[0]))
			$views[$row[0]]=$row[1];

	}
	return $views;

}

/* Get all hosts in this view */
/* Helper for get_host_recursive and used in smap.php */
function get_host_in_view($view){
	$tmp = sql_exec_query("SELECT DISTINCT host FROM smap_content WHERE " .
						  "smap_view='$view' AND host is not null ORDER BY host");
	$i=0;
	global $auth;
	$hosts =array();
    while($row = sql_fetch_row($tmp)) {
		if($auth===true || isset($auth['host'][$row[0]])){
			$hosts[$i]=$row[0];
	    	$i=$i+1;
		}
	}
	return $hosts;
}

/* Used by smap_image_utils.inc.php (move there???) */
/* Needed since a view can include views that include hosts... */
function get_host_recursive($view){
	$h = array();
	$h = get_host_in_view($view);
	$v = get_view_in_view($view);
	foreach($v as $one_v=>$tjippp){
		$h2=get_host_recursive($one_v);
		$h = array_merge($h,$h2);
	}
	$h = array_unique($h);
	sort($h);
	return $h;
}

/* Only helper for get_host_recursive */
function get_view_in_view($view){
	$tmp = sql_exec_query("SELECT DISTINCT view FROM smap_content LEFT JOIN " .
						  "smap_view ON id=smap_content.smap_view WHERE " .
						  "smap_content.smap_view='" .
						  mysql_escape_string($view) . "' AND NOT view=''");

	$dbStr = "SELECT DISTINCT id, name FROM smap_view WHERE id IN (";

	while($row = sql_fetch_row($tmp)){
		$dbStr=$dbStr . "'$row[0]', ";
	}
	$dbStr=$dbStr . "'') ORDER BY name";
	$i=0;
	$views_tmp = sql_exec_query($dbStr);
	$views =array();
	while($row = sql_fetch_row($views_tmp)) {
		$i=$i+1;
		$views[$row[0]]=$row[1];
	}
	return $views;
}

/* Only helper for get_host_recursive */
function get_customview_in_view($view){
	$tmp = sql_exec_query("SELECT DISTINCT view FROM smap_content LEFT JOIN " .
						  "smap_view ON id=smap_content.smap_view WHERE " .
						  "smap_content.smap_view='" .
						  mysql_escape_string($view) . "' AND NOT view='' ");


	$dbStr = "SELECT DISTINCT id, name FROM smap_view WHERE is_hostgroup is null AND id IN (";

	while($row = sql_fetch_row($tmp)){
		$dbStr=$dbStr . "'$row[0]', ";
	}
	$dbStr=$dbStr . "'') ORDER BY name";
	$i=0;
	$views_tmp = sql_exec_query($dbStr);
	$views =array();
	while($row = sql_fetch_row($views_tmp)) {
		if(user_has_rights($row[0])){
			$i=$i+1;
			$views[$row[0]]=$row[1];
		}
	}
	return $views;
}

/* Get all hosts */
function get_all_hosts(){
	$tmp=sql_exec_query("SELECT host_name FROM host ORDER BY host_name");
	$i=0;
	global $auth;
    $hosts =array();
    while($row = sql_fetch_row($tmp)) {
		if($auth===true || isset($auth['host'][$row[0]])){
        	$hosts[$i]=$row[0];
        	$i=$i+1;
		}
	}
    return $hosts;
}

# shaky and primitive function that caculates roughly suitable
# coords for new items in any given view
# the $coords_last set of globals are used to speed up db syncing
$coords_last_view = false;
$coords_last_res = false;
$coords_last_bg_size = false;
function get_new_item_coords($view)
{
	global $coords_last_view, $coords_last_bg_size, $coords_last_res;

	if ($view === $coords_last_view) {
		$bg_size = $coords_last_bg_size;
		$acc_width = $coords_last_res['x'] + START_WIDTH;
		$acc_height = $coords_last_res['y'] + START_HEIGHT;
	}
	else {
		$coords_last_view = $view;
		$acc_height = START_HEIGHT;
		$acc_width = START_WIDTH;
		$res = sql_exec_query("SELECT background FROM smap_view WHERE id=" . $view);
		$row = sql_fetch_row($res);
		$bg_size=get_pic_size($row[0]);
	}

	# this is the stupid part. We should be able to do this
	# much smarter (like by using Flash, fe)
	while(1){

		if(($acc_height + ICON_HEIGHT + FONT_SIZE * 3) > ($bg_size['y'] - START_HEIGHT * 2)) {
			$acc_width += START_WIDTH + ICON_WIDTH * ICON_SPACING_HORIZONTAL;
			$acc_height = START_HEIGHT;
		 }

		$res= sql_exec_query("SELECT * FROM smap_content WHERE x=" . $acc_width .
						     " AND y=" . $acc_height . " AND smap_view=" .  $view);
		if(sql_fetch_row($res)){
		    $acc_height += ICON_HEIGHT * ICON_SPACING_VERTICAL + FONT_SIZE * 4;
		} else {
			$res=array();
			$res['x'] = $acc_width;
			$res['y'] = $acc_height;
			$coords_last_res = $res;
			return $res;
		}
	}
}

function is_coord_used($view, $x, $y){

	$res = sql_exec_query("SELECT * FROM smap_content WHERE smap_view=" . $view .
							" AND x=". $x . " AND y=" . $y);
	if(sql_fetch_row($res)){
		return true;
	}
	return false;
}

/* Deletes a custom view and all its children */
function delete_view_recursive($view){
	$children = sql_exec_query("SELECT view FROM smap_content LEFT JOIN " .
							   "smap_view ON id = smap_view WHERE ".
							   "smap_view = " . $view . " AND " .
							   "is_hostgroup!=1");

	while($one_child = sql_fetch_row($children)){
		delete_view_recursive($one_child[0]);
	}
	sql_exec_query("DELETE FROM smap_content WHERE smap_view = " . $view);
	sql_exec_query("DELETE FROM smap_content WHERE view = ". $view);
	sql_exec_query("DELETE FROM smap_view WHERE id = " . $view);
}


function create_sample_view(){
	$host_groups = sql_exec_query("SELECT id FROM smap_view WHERE id!=1");
	$sample_view_id = add_view("Sample view", 1);
	while($grp = sql_fetch_row($host_groups)){
		add_view_to_view($grp[0], $sample_view_id);
	}
}


function create_sample_view2(){
	$host_groups = sql_exec_query("SELECT id FROM smap_view WHERE id!=1");
	while($grp = sql_fetch_row($host_groups)){
		add_view_to_view($grp[0], 1);
	}
}


function get_default_background(){
	$bg_link = BG_DIR . "/default";
	if(!is_link($bg_link)){
		return BACKGROUND;
	}
	if($default_bg = readlink($bg_link)){
		return $default_bg;
	} else {
		return BACKGROUND;
	}
}


function rename_view($view, $new_name){
	$uniqueName = check_name_unique($new_name);
	if(!$uniqueName){
		return false;
	}
	/* CHECK NAME!!!!! */
	sql_exec_query("UPDATE smap_view SET name='" .
				   mysql_escape_string($new_name) .
				   "' WHERE id=$view");
	return true;
}

/* Check if viewName exists as hostgroup or view */
function check_name_unique($viewName){
	$res = sql_exec_query("SELECT * FROM smap_view WHERE name='" .
						  $viewName . "'");
	while($tmp = sql_fetch_row($res)){
		return false;
	}
	$res = sql_exec_query("SELECT * FROM hostgroup WHERE hostgroup_name='" .
						  $viewName . "'");
	while($tmp = sql_fetch_row($res)){
		return false;
	}
	return true;
}

# run only once, when the database gets initialized
function smap_db_first_sync_ever()
{
	sql_exec_query("INSERT INTO smap_view (id, name) VALUES (1, 'Root view')");
	sql_exec_query("INSERT INTO smap_view (name) SELECT hostgroup_name FROM hostgroup");
	sql_exec_query("INSERT INTO smap_content (view) SELECT id FROM smap_view WHERE smap_view.id != 1");
	sql_exec_query("UPDATE smap_content SET smap_view = 1");
	sql_exec_query("UPDATE smap_view SET is_hostgroup = 1 WHERE id!=1");

	$hosts = sql_exec_query
		("SELECT smap_view.id, host_name FROM hostgroup LEFT JOIN " .
		 "host_hostgroup on hostgroup.id=host_hostgroup.hostgroup " .
		 "LEFT JOIN host on host.id = host_hostgroup.host LEFT JOIN " .
		 "smap_view ON hostgroup_name = name WHERE host_name IS NOT NULL");
	while($line = sql_fetch_row($hosts)) {
		$query_str ="INSERT INTO smap_content (smap_view, host) VALUES ({$line[0]},'{$line[1]}')";
		sql_exec_query($query_str);
	}

	$hostgroups = sql_exec_query("SELECT hostgroup_name FROM hostgroup");
	while($line = sql_fetch_row($hostgroups)) {
		$view = sql_exec_query("SELECT name FROM smap_view WHERE smap_view.name ='{$line[0]}'");
		$rows = mysql_num_rows($view);
		if($rows === 0) {
			sql_exec_query("INSERT INTO smap_view (name, is_hostgroup) VALUES ('{$line[0]}', 1)");
/* Part of root fix stuff...don't add anything to root automatically */
			$res = sql_exec_query("SELECT MAX(id) FROM smap_view");
			$line = sql_fetch_row($res);
			sql_exec_query("INSERT INTO smap_content (smap_view,view) VALUES (1,{$line[0]})");
		}
	}

	/* Add a sample custom view */
	return true;
}


//get_host_not_in_view(117);
// sync object db with statusmap.
// delete from statusmap if deleted in object-db
// add to statusmap if added in object-db
function smap_db_sync() {
	echo "Syncing db..  ";
	$result = sql_exec_query("SELECT count(id) FROM smap_view");
	$row = sql_fetch_row($result);

	# If status is empty, add all hosts and hostgroups
	if($row[0] === '0' || $row[0] == 0)
		return smap_db_first_sync_ever();

	sql_exec_query("UPDATE smap_view SET name='Root view' WHERE id=1 AND name='*'");

	# For unknown reasons the Root view have been lost on some installations so to
	# recover from such a problem we re-create the root view if it's missing.
	sql_exec_query("INSERT IGNORE INTO smap_view (id, name) VALUES (1,'Root view')");

	# Orphaned views need a 'parent' so any view without a parent is placed under the root.
	$query="select id from smap_view where is_hostgroup IS  NULL AND id != 1 AND " .
	  "id NOT IN (SELECT view FROM smap_content WHERE view IS NOT NULL)";
	$result = sql_exec_query($query);
	while ($row = sql_fetch_row($result)) {
		sql_exec_query("INSERT INTO smap_content(smap_view, view) VALUES(1, $row[0])");
	}

	# delete hostgroups from smap_view that aren't in object database
	$query = 'DELETE FROM smap_view WHERE is_hostgroup = 1 AND ' .
			'name NOT IN (SELECT hostgroup_name FROM hostgroup)';
	$result = sql_exec_query($query);

	# delete hosts from newly deleted hostgroups
	$query = 'DELETE FROM smap_content WHERE smap_view NOT IN ' .
		'(SELECT id FROM smap_view)';
	$result = sql_exec_query($query);

	# Delete host from view if the host is not in object-cache
	$del_query = 'DELETE FROM smap_content ' .
		'WHERE host NOT IN (SELECT host_name FROM host)';
	$result = sql_exec_query($del_query);

	# add hostgroups missing from smap_view
	$query = 'SELECT hostgroup_name FROM hostgroup ' .
		'WHERE hostgroup_name NOT IN ' .
		'(SELECT name FROM smap_view WHERE is_hostgroup = 1)';
	$result = sql_exec_query($query);
	while ($row = sql_fetch_row($result)) {
		$hostgroup_name = $row[0];
		sql_exec_query('INSERT INTO smap_view(name, is_hostgroup) ' .
		               "VALUES('$hostgroup_name', 1)");
	}

	# create the smap_view index
	$query = 'SELECT smap_view.name, smap_view.id FROM smap_view WHERE is_hostgroup = 1';
	$result = sql_exec_query($query);
	$smap_view_id = array();
	while ($row = sql_fetch_row($result))
		$smap_view_id[$row[0]] = $row[1];

	# now build the tree of hosts in the smap database
	$query = 'SELECT smap_view.name, smap_content.host, smap_view.id ' .
		'FROM smap_view, smap_content ' .
		"WHERE smap_content.host != '' " .
		'AND smap_view.is_hostgroup = 1 ' .
		'AND smap_content.smap_view = smap_view.id';
	$result = sql_exec_query($query);
	$smap_content = array();
	while ($row = sql_fetch_row($result))
		$smap_content[$row[0]][$row[1]] = $row[1];

	# insert hosts missing from status map
	$old_query = "SELECT hostgroup_name, host_name FROM host " .
		"LEFT JOIN host_hostgroup on host.id=host_hostgroup.host " .
		"LEFT JOIN hostgroup on host_hostgroup.hostgroup=hostgroup.id";
	# "explain select" claims this one has vastly
	# better performance patterns than old_query
	$query = 'SELECT hostgroup.hostgroup_name, host.host_name ' .
		'FROM host, hostgroup, host_hostgroup ' .
		'WHERE hostgroup.id = host_hostgroup.hostgroup ' .
		'AND host.id = host_hostgroup.host';

	$result = sql_exec_query($query);
	while ($row = sql_fetch_row($result)) {
		# if this one's already present in the smap_content, we
		# don't bother with it, but we do remove it from the
		# array. This way we know which hosts should be removed
		# from which views later (ie, the remaining ones)
		if (isset($smap_content[$row[0]][$row[1]])) {
			unset($smap_content[$row[0]][$row[1]]);
			continue;
		}

		# the host doesn't exist in this hostgroup view, so insert it

		$host_name = $row[1];
		$view_id = $smap_view_id[$row[0]];

		$coords = get_new_item_coords($view_id, 0);
		$x = $coords['x']; $y = $coords['y'];
		sql_exec_query('INSERT INTO smap_content(smap_view, host, x, y) ' .
		               "VALUES ($view_id, '$host_name', '$x', '$y')");
	}

	# Now take the remnants from the $smap_content array and
	# delete from the view. We know the host isn't supposed
	# to be there, or it would have been removed up above
	foreach ($smap_content as $view_name => $host_list) {
		if (empty($host_list))
			continue;

		$view_id = $smap_view_id[$view_name];
		foreach ($host_list as $host) {
			$query = 'DELETE FROM smap_content ' .
				"WHERE smap_view = $view_id AND " .
				"host = '$host'";
			sql_exec_query($query);
		}
	}

	// Delete hostgroups and views that have been placed in other hostgroups...
	$tmp = sql_exec_query("select smap_view, view from smap_content LEFT JOIN " .
						  "smap_view ON smap_view.id=smap_content.smap_view " .
						  "WHERE smap_view.is_hostgroup=1 AND " .
						  "view IS NOT NULL");
	while($toDelete = sql_fetch_row($tmp)){
		sql_exec_query("DELETE FROM smap_content WHERE smap_view="
					   . $toDelete[0] . " AND view=" . $toDelete[1]);
	}

	return true;
}




// Set coord for host or view.
// View icons are 2*host icons in width and height. To make this really
// nice that should be considered when cetering img.
function update_coordinates($x, $y, $selected_host, $selected_view){
	global $view;
	global $scale;

	// place img centered on the point clicked.
	$x_scaled = ($x/$scale)-ICON_WIDTH;
	$y_scaled = ($y/$scale)-ICON_HEIGHT;

	// ... but not too close to the edge
	if($x_scaled < ICON_WIDTH) {
		$x_scaled = ICON_WIDTH;
	}
	elseif($x_scaled > MAP_WIDTH - (ICON_WIDTH * 2)) {
		$x_scaled = MAP_WIDTH - (ICON_WIDTH * 2);
	}

	if($y_scaled < ICON_HEIGHT) {
		$y_scaled = ICON_HEIGHT;
	}
	elseif($y_scaled > MAP_HEIGHT - (ICON_HEIGHT * 2)) {
		$y_scaled = MAP_HEIGHT - (ICON_HEIGHT * 2);
	}

	if($selected_host === false) {
		sql_exec_query("UPDATE smap_content SET x={$x_scaled},y={$y_scaled} " .
		               "WHERE smap_view={$view} AND view={$selected_view}");

	}
	if($selected_view === false) {
		sql_exec_query("UPDATE smap_content SET x={$x_scaled}, y={$y_scaled} " .
		               "WHERE smap_view={$view} AND host='{$selected_host}'");
	}

}


//Get the object clicked (if any). Return hostname if host found
//Return view ID if view found. False if no hit.
//Ignores the fact that view and host icons differ in size
function get_clicked_object($x, $y) {
	global $all_objects;
	global $view;
	global $scale;
	global $auth;
    $result = 0;

	if($x === false || $y === false) return(false);

	$all_objects=sql_exec_query("SELECT smap_view, view, host, x, y FROM smap_content WHERE " .
								"smap_view = '{$view}' ORDER BY y ASC");

	while($line = sql_fetch_row($all_objects)){
		$x_clicked = $x/$scale;
		$y_clicked = $y/$scale;
		$x_scaled = $line[3];
		$y_scaled = $line[4];
		$x_hit=false;
		$y_hit=false;

		if (($x_clicked >= ($x_scaled)) &&
			($x_clicked <= ($x_scaled + (2*ICON_WIDTH)))) {
			$x_hit=true;
		}
		if (($y_clicked >= ($y_scaled)) &&
			($y_clicked <= ($y_scaled + (2*ICON_HEIGHT)))) {
			$y_hit=true;
		}

		/* check that user has rights */

		if($y_hit && $x_hit){
			if ($line[2]!="" && ($auth===true || isset($auth['host'][$line[2]]))){
				return $line[2];
			}
			if ($line[1]!="" && user_has_rights($line[1])){
				return $line[1];
			}
		}
	}

	return false;
}

?>
